#pragma once

#include <ge211.hxx>
#include <memory>
#include <map>

namespace widget
{

namespace detail
{

struct ISprite_set
{
    virtual void add_sprite(ge211::Sprite const&,
                            ge211::Position,
                            int,
                            ge211::Transform) = 0;
};

class Sprite_set_adapter : ISprite_set
{
    ge211::Sprite_set& base_;

public:
    explicit Sprite_set_adapter(ge211::Sprite_set& base)
            : base_(base)
    { }

private:
    void add_sprite(ge211::Sprite const&,
                    ge211::Position,
                    int z,
                    ge211::Transform) override;
};

struct Sprite_tree_link
{
    virtual int do_draw(ISprite_set&, int z) = 0;
    virtual ~Sprite_tree_link() = default;
};

class Sprite_tree : private Sprite_tree_link
{
public:
    Sprite_tree&
    add_branch(Sprite_tree&& branch,
               int z = 0) &;

    Sprite_tree&
    add_leaf(ge211::Sprite const&,
             ge211::Position,
             int z = 0,
             ge211::Transform const& = ge211::Transform()) &;

    Sprite_tree&&
    add_branch(Sprite_tree&& branch,
               int z = 0) &&;

    Sprite_tree&&
    add_leaf(ge211::Sprite const&,
             ge211::Position,
             int z = 0,
             ge211::Transform const& = ge211::Transform()) &&;

    int draw(ISprite_set&, int);

protected:
    int do_draw(ISprite_set&, int) override;

private:
    std::multimap<int, std::unique_ptr<Sprite_tree_link>>
            children_;
};

} // end namespace detail

} // end namespace widget

